/*
  azar.cc
*/
#include "rotuloTexto.h"
#include "rotuloHanzi.h"
#include "rotuloPinyin.h"
#include "azar.h"
#include <stdlib.h>
#include <string.h>


Azar::Azar(Datos *dat)
{
  d=dat;
}

char *Azar::pregunta(int tipo)
{
  switch(tipo)
  {
    case 1:
    case 2:  return d->hanzi();
    case 3:  return d->traduccion();
    case 4:  return d->pinyin();
  }
  return 0;
}

char *Azar::compl(int tipo)
{
  switch(tipo)
  {
    case 1:  return d->pinyin();
    case 2:  return d->traduccion();
    case 3:  return d->pinyin();
    case 4:  return d->traduccion();
  }
  return 0;
}

char *Azar::respuesta(int tipo)
{
  switch(tipo)
  {
    case 1:  return d->traduccion();
    case 2:  return d->pinyin();
    case 3:
    case 4:  return d->hanzi();
  }
  return 0;
}

void Azar::seleccionarRespuesta(int i,int tipo,int &n,int num)
{
int j;
int salir=0;
int v;

  v=0;
  while(v++<500&&!salir)
  {
    r[i]=respuesta(tipo);
    if(rand()%10>8)
    {
     salir=1;
     for(j=i-1;j>=1;j--)
       if(!strcmp(r[i],r[j]))
       {
	 salir=0;
	 break;
       }
    }
    d->rotar();
    n = (n+1)%num;
  }
}

void Azar::sorteo(int tipo)
{
  int n,num,i,j;
  char *p;

  n=0;
  num=d->numero();
  r[0]=pregunta(tipo);
  r1=compl(tipo);
  resp=r[1]=respuesta(tipo);
  for(i=2;i<=opciones;i++)
   r[i]=r[1];

  for(i=2;i<=opciones;i++)
    seleccionarRespuesta(i,tipo,n,num);

  while(n)
  {
    d->rotar();
    n = (n+1)%num;
  }
  for(n=0;n<30;n++)
  {
   i=rand()%opciones+1;
   j=rand()%opciones+1;
   p=r[i];
   r[i]=r[j];
   r[j]=p;
  }
}

Azar::~Azar()
{
}

